@Library('sharedlibs') _

pipeline {
    agent any
    environment {
        INITIAL_BUILD_STATUS = false
        ATLEAST_ONE_SUCCESS_BUILD = false
    }
    stages {
        stage('Docker Build') {
            steps {
                script{
                    try {
                        sh 'docker-compose build'
                        // sh 'exit 1' 

                        echo "initial build success"
                        INITIAL_BUILD_STATUS = true
                        ATLEAST_ONE_SUCCESS_BUILD = true
                        currentBuild.result = "SUCCESS"
                        github.log("library is working")
                    } catch(err) {
                        echo "Caught: ${err}"
                        // currentStage.result = 'UNSTABLE'
                        unstable("Latest build has not succeeded")
                        INITIAL_BUILD_STATUS = false
                    }
                }
            }
        }

          stage('Reverting to previous build'){
            when { expression { return INITIAL_BUILD_STATUS == false } }
            steps {
                script {
                // echo "Fetching Previous Commit with SHA: ${env.GIT_PREVIOUS_SUCCESSFUL_COMMIT}"
                // checkout([$class: 'GitSCM', branches: [[name: "${env.GIT_PREVIOUS_SUCCESSFUL_COMMIT}"]], extensions: [], userRemoteConfigs: [[url: 'https://gitlab.com/levinson.dsouza/fastapi-project.git']]])           
                //     try {
                //         sh 'docker-compose build'
                //         // sh 'exit 1' 

                //         echo "Reverted build success"
                //         INITIAL_BUILD_STATUS = true
                //         ATLEAST_ONE_SUCCESS_BUILD = true
                //         currentBuild.result = "SUCCESS"
                //     } catch(err) {
                //         echo "Caught: ${err}"
                //         // currentStage.result = 'UNSTABLE'
                //         INITIAL_BUILD_STATUS = false
                //         unstable("""
                //         Git Commit with SHA ${env.GIT_COMMIT_HASH}has failed as well, Flagging
                //         Build as failed
                //         """)
                //         currentBuild.result = 'FAILURE'
                //     }

                PREV_SUCCESS_BUILD = sh ( 
                        script: """
                            curl http://192.168.13.35:8080/job/Levinson-Jenkins-Nightly-Multibranch/job/master/lastSuccessfulBuild/api/json --user levinson:dsouza | python -c 'import sys, json; print(json.load(sys.stdin)["id"])'
                            """,
                        returnStdout: true
                    ).trim()

                    

                
                    echo "Using PREV_BUILD ${PREV_SUCCESS_BUILD}"
                    sh "curl http://192.168.13.35:8080/job/Levinson-Jenkins-Nightly-Multibranch/job/master/${PREV_SUCCESS_BUILD}/rebuild/ --user levinson:dsouza"

                    echo "Sent rebuild request successfully?"

                    // do I need to set build as unstable?
                    unstable("Setting current build as unstable and reverting to build ${PREV_SUCCESS_BUILD}")

                    sh "exit 1"
                    
                
                }
                
                }
            }

        stage('Docker Push') {
            when { expression { return ATLEAST_ONE_SUCCESS_BUILD == true }}
            steps{
                sh "docker login -u=levinson25 -p=Dsouza@2504"
                sh 'docker-compose push'
            }
        }
    }
}

// GITLAB build trigger

def project_token = 'glpat-YSsjWBEfSuMYbGJyMvbe'

// Reference the GitLab connection name from your Jenkins Global configuration (https://JENKINS_URL/configure, GitLab section)
properties([
    gitLabConnection('Nightly-Jenkins-Gitlab-Trigger-Build'),
    pipelineTriggers([
        [
            $class: 'GitLabPushTrigger',
            branchFilterType: 'All',
            triggerOnPush: true,
            triggerOnMergeRequest: false,
            triggerOpenMergeRequestOnPush: "never",
            triggerOnNoteRequest: true,
            noteRegex: "Jenkins please retry a build",
            skipWorkInProgressMergeRequest: true,
            secretToken: project_token,
            ciSkip: false,
            setBuildDescription: true,
            addNoteOnMergeRequest: true,
            addCiMessage: true,
            addVoteOnMergeRequest: true,
            acceptMergeRequestOnSuccess: false,
            branchFilterType: "NameBasedFilter",
            includeBranchesSpec: "release/qat",
            excludeBranchesSpec: "",
        ]
    ])
])